
// ClipMMDoc.cpp : CClipMMDoc NX̎
//

#include "stdafx.h"
#include "ClipMM.h"
#include "ClipMMDoc.h"

//#include <propkey.h>
#include "Util.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CClipMMDoc

IMPLEMENT_DYNCREATE(CClipMMDoc, CDocument)

BEGIN_MESSAGE_MAP(CClipMMDoc, CDocument)
	ON_COMMAND(ID_EDIT_PASTE, &CClipMMDoc::OnEditPaste)
	ON_COMMAND(ID_EDIT_PASTE_FORMAT, &CClipMMDoc::OnEditPasteFormat)
END_MESSAGE_MAP()


// CClipMMDoc RXgNV/fXgNV

CClipMMDoc::CClipMMDoc()
{
	// TODO: ̈ʒu 1 xĂ΂\zp̃R[hǉĂB

}

CClipMMDoc::~CClipMMDoc()
{
}

BOOL CClipMMDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: ̈ʒuɍďǉĂB
	// (SDI hLg͂̃hLgėp܂B)

	return TRUE;
}




// CClipMMDoc VA

void CClipMMDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: i[R[hɒǉĂB
	}
	else
	{
		// TODO: ǂݍރR[hɒǉĂB
	}
}

// CClipMMDoc ff

#ifdef _DEBUG
void CClipMMDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CClipMMDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CClipMMDoc R}h

void CClipMMDoc::OnEditPaste()
{
	DWORD nSeq = GetClipboardSequenceNumber();

	m_strSrc.Format(L"Nbv{[h#%u", nSeq);
	SetTitle(m_strSrc);

	COleDataObject dataObject;
	if (dataObject.AttachClipboard()) 
	{
		if (m_pArray)
		{
			auto pArrayOld = m_pArray;	// Sr[܂ō폜Ȃ悤QƃJEg𑝂₵Ă
			m_pArray = nullptr;
			UpdateAllViews(NULL, updatehintReset);
		}

		m_pArray = make_shared<CCBDataArray>();
		vector<FORMATETC> arrayFMTETC;
		CCBDataArray::EnumAllFormats(&dataObject, arrayFMTETC);
		try 
		{
			m_pArray->CreateItems(&dataObject, arrayFMTETC);
		}
		catch (std::bad_alloc)
		{
			m_pArray = nullptr;
			AfxMessageBox(L"܂B");
		}

		FORMATETC2ShortStringArray(arrayFMTETC, m_arrayFormatNames);

		UpdateAllViews(NULL, updatehintReset);

	}
}


void CClipMMDoc::OnEditPasteFormat()
{
	DWORD nSeq = GetClipboardSequenceNumber();

	COleDataObject dataObject;
	if (dataObject.AttachClipboard())
	{
		// StH[}bg
		vector<FORMATETC> arrayFMTETC;
		CCBDataArray::EnumAllFormats(&dataObject, arrayFMTETC);

		vector<FORMATETC> arrayFMTETCSelected;
		FormatPopupMenu(arrayFMTETC, arrayFMTETCSelected);
		if (!arrayFMTETCSelected.empty())
		{
			m_strSrc.Format(L"Nbv{[h#%u", nSeq);
			SetTitle(m_strSrc);

			if (m_pArray)
			{
				auto pArrayOld = m_pArray;	// Sr[܂ō폜Ȃ悤QƃJEg𑝂₵Ă
				m_pArray = nullptr;
				UpdateAllViews(NULL, updatehintReset);
			}

			m_pArray = make_shared<CCBDataArray>();
			try 
			{
				m_pArray->CreateItems(&dataObject, arrayFMTETCSelected);
			}
			catch (std::bad_alloc)
			{
				m_pArray = nullptr;
				AfxMessageBox(L"܂B");
			}

			FORMATETC2ShortStringArray(arrayFMTETC, m_arrayFormatNames);

			UpdateAllViews(NULL, updatehintReset);
			UpdateAllViews(NULL, updatehintSelChild);
		}
	}
}

BOOL CClipMMDoc::OnDataDrop(COleDataObject* pDataObject, BOOL bSelectFormat)
{
	CClipMMApp* pApp = (CClipMMApp*)AfxGetApp();
	::SetForegroundWindow(pApp->m_pMainWnd->GetSafeHwnd());

	// StH[}bg
	vector<FORMATETC> arrayFMTETC;
	CCBDataArray::EnumAllFormats(pDataObject, arrayFMTETC);

	vector<FORMATETC> arrayFMTETCSelected;

	if (bSelectFormat)
	{
		FormatPopupMenu(arrayFMTETC, arrayFMTETCSelected);
	}
	else
	{
		arrayFMTETCSelected = arrayFMTETC;
	}

	if (!arrayFMTETCSelected.empty())
	{
		CTime timeNow = CTime::GetCurrentTime();
		m_strSrc.Format(L"hbvf[^ %02d:%02d:%02d", timeNow.GetHour(), timeNow.GetMinute(), timeNow.GetSecond());
		SetTitle(m_strSrc);

		if (m_pArray)
		{
			auto pArrayOld = m_pArray;	// Sr[܂ō폜Ȃ悤QƃJEg𑝂₵Ă
			m_pArray = nullptr;
			UpdateAllViews(NULL, updatehintReset);
		}

		m_pArray = make_shared<CCBDataArray>();
		try 
		{
			m_pArray->CreateItems(pDataObject, arrayFMTETCSelected);
		}
		catch (std::bad_alloc)
		{
			m_pArray = nullptr;
			AfxMessageBox(L"܂B");
		}

		FORMATETC2ShortStringArray(arrayFMTETC, m_arrayFormatNames);

		UpdateAllViews(NULL, updatehintReset);
		if (bSelectFormat)
			UpdateAllViews(NULL, updatehintSelChild);
		return TRUE;
	}
	return FALSE;
}

void CClipMMDoc::FormatPopupMenu(vector<FORMATETC>& arrayFMTETC, vector<FORMATETC>& arrayFMTETCSelected)
{
	arrayFMTETCSelected.clear();

	CPoint pt(0, 0);
	GetCursorPos(&pt);

	CMenu menu;
	menu.CreatePopupMenu();

	const int nCommandBase = 10000;
	for (int i = 0; i < (int)arrayFMTETC.size(); i++)
	{
		UINT nFlags = 0;
		if (i >= 20 && (i % 20) == 0)
		{
			nFlags |= MF_MENUBARBREAK;
		}
		menu.AppendMenu(MF_STRING | nFlags, nCommandBase + i, DoubleAmp(FORMATETC2ShortString(arrayFMTETC[i])));
	}

	int nCommandSelected = 
	menu.TrackPopupMenu(TPM_LEFTALIGN | TPM_TOPALIGN | TPM_NONOTIFY | TPM_RETURNCMD, 
									pt.x,
									pt.y,
									AfxGetApp()->m_pMainWnd,
									NULL);

	if (nCommandSelected)
	{
		int nSelected = nCommandSelected - nCommandBase;
		if (nSelected >= 0 && nSelected < (int)arrayFMTETC.size())
		{
			if (arrayFMTETC[nSelected].cfFormat == g_cfFileContents)
			{
				// YFileDescriptorǉ
				int nFileDescriptorA = -1;
				int nFileDescriptorW = -1;
				for (int i = 0; i < (int)arrayFMTETC.size(); i++)
				{
					if (arrayFMTETC[i].cfFormat == g_cfFileDescriptorA &&
						arrayFMTETC[i].dwAspect == arrayFMTETC[nSelected].dwAspect)
					{
						nFileDescriptorA = i;
					}
					if (arrayFMTETC[i].cfFormat == g_cfFileDescriptorW &&
						arrayFMTETC[i].dwAspect == arrayFMTETC[nSelected].dwAspect)
					{
						nFileDescriptorW = i;
					}
				}
				if (nFileDescriptorW >= 0)
				{
					arrayFMTETCSelected.push_back(arrayFMTETC[nFileDescriptorW]);
				}
				else if (nFileDescriptorA >= 0)
				{
					arrayFMTETCSelected.push_back(arrayFMTETC[nFileDescriptorA]);
				}
			}
			arrayFMTETCSelected.push_back(arrayFMTETC[nSelected]);
		}
	}
}
